# use Miniconda environment
#author = "Kang Yang"
#copyright = "Copyright 2017, Nanjing Greenland Hydrology Group"
#license = "GPL"
#version = "0.1"
#maintainer = "Kang Yang"
#email = "kangyang@nju.edu.cn"
#status = "Production"
#description = "extract water mask files by combining river detections and ndwi-thresholding lake detections"


import arcpy,os,sys
from arcpy import env
from arcpy.sa import *


env.overwriteOutput=True
arcpy.CheckOutExtension("Spatial")
env.workspace=r'D:\00_river_detection\0000_processed_LandsatNDWI\0_matlab_GrIS_river_detection_Greenland_2014_2016\2016'
env.extent="MAXOF"    #this sentence is important to keeep the same extent during processing
ndwiFilePath=r'E:\bda\GrIS_Landsat8_NDWI_images'
outputPath = r'E:\1.GrIS_river_evolution\water_mask\2016'
if os.path.exists(outputPath)==False:
        os.mkdir(outputPath)

# use the DOY 
#DOYList = ["164","182","189","198","205","214","237"]
DOYList = ["210"]

tgabor=25   #the thredhold to classify raster and get river mask, default 25
tndwi=0.25  #the threshold to classify ndwi raster and get lake mask, default 0.25

#for DOY 214, 205, 2015, tgabor = 10, tndwi = 0.15
#for DOY 119, 135, 2016, tndwi = 0.30
#for DOY 144, 2016, tgabor = 10, tndwi = 0.2
#for DOY 151, 153, 2016, tgabor = 10, tndwi = 0.1
#for DOY 160, 2016, tgabor = 10, tndwi = 0.2

rasters = arcpy.ListRasters("*", "tif")
for gaborRaster in rasters:

    if not "cpo" in gaborRaster:
        continue

    sign = 0
    for doy in DOYList:
        if "0132016" + doy in gaborRaster:
            sign = 1
            break;
    if sign == 0:
        continue;


    print gaborRaster
    strList=gaborRaster.split('_')
    identifer=strList[1]
    ndwiFile = "ndwi_" + identifer + ".tif"
    watermaskFile = os.path.join(outputPath,"temp_watermask_"+ndwiFile.split('_')[1])
    
    riverRaster = Con(Raster(gaborRaster)>=tgabor,1,0)
            
    lakeRaster  = Con(Raster(os.path.join(ndwiFilePath,ndwiFile))>=tndwi,1,0)
    #lakeRaster  = Raster(r'E:\1.GrIS_river_evolution\water_mask\2016\DOY208_217_special_processing\temp_watermask_LC80070132016208LGN00.tif')


    waterRaster = riverRaster + lakeRaster
    finalwaterRaster = Reclassify(waterRaster,"Value","0 0; 1 1; 2 1","NODATA")
    finalwaterRaster.save(watermaskFile)
    arcpy.CalculateStatistics_management(watermaskFile)
    arcpy.BuildPyramids_management(watermaskFile)  