# use Miniconda environment
#author = "Kang Yang"
#copyright = "Copyright 2017, Nanjing Greenland Hydrology Group"
#license = "GPL"
#version = "0.1"
#maintainer = "Kang Yang"
#email = "kangyang@nju.edu.cn"
#status = "Production"
#description = "zonal statistics of water masks and get water area (in pixels) for different eleavation bins (or other regions)"


import arcpy
import os
from arcpy import env
from arcpy.sa import *

arcpy.CheckOutExtension("Spatial")
env.workspace=r'E:\1.GrIS_river_evolution\water_mask\2015\Watson_Isortoq'
env.overwriteOutput=True
outputPath=r'E:\1.GrIS_river_evolution\water_mask\2015\Watson_Isortoq\zonalstats'
if os.path.exists(outputPath)==False:
        os.mkdir(outputPath)

eleBin=r'E:\1.GrIS_river_evolution\1_DEM\basin_watson_isortoq_30m_gimp_v2_reclassfication_polygon.shp'
#eleBin=r'E:\1.GrIS_river_evolution\1_DEM\basin_watson_30m_gimp_v2_reclassfication_polygon.shp'
env.extent = "MINOF"


eleBin_pt = outputPath + "\\ele_pt_waterarea.shp"
arcpy.FeatureToPoint_management(eleBin, eleBin_pt, "INSIDE")


tiffs = arcpy.ListRasters("*","tif")
for tiff in tiffs:
    print "process " + tiff
    zonalRaster = outputPath + "\\" + tiff.split('.')[0] + "_zonalSum.tif"
    outZonalStatistics=ZonalStatistics(eleBin,"ID",tiff,"SUM")
    outZonalStatistics.save(zonalRaster)

env.workspace = outputPath
tiffs = arcpy.ListRasters("*","tif")
for tiff in tiffs:
    if 'lake' in tiff:
        continue
    if 'B13' in tiff:
        continue
    day = (tiff.split("2015")[1])[0:3]
    print day
    ExtractMultiValuesToPoints(eleBin_pt,[[tiff,day]])
        
        


        
        
        



                
            
