# use Miniconda environment
#author = "Kang Yang"
#copyright = "Copyright 2017, Nanjing Greenland Hydrology Group"
#license = "GPL"
#version = "0.1"
#maintainer = "Kang Yang"
#email = "kangyang@nju.edu.cn"
#status = "Production"
#description = "add necessary fields to rivers and lakes"

import arcpy
import os
from arcpy import env
from arcpy.sa import *

arcpy.CheckOutExtension("Spatial")
env.workspace=r'E:\1.GrIS_river_evolution\water_mask\2016\Watson_Isortoq\0_river_and_lake_shapefiles'
#env.workspace=r'E:\1.GrIS_river_evolution\water_mask\2015\Watson_Isortoq\0_river_and_lake_shapefiles\large_lake_and_river_shapefiles_for_paper'
env.overwriteOutput=True

featureclasses = arcpy.ListFeatureClasses()
for fc in featureclasses:
        if "lake" in fc:
                print "process " + fc
                arcpy.AddField_management(fc,"count","INTEGER")
                arcpy.CalculateField_management(fc, "count", "1", "PYTHON")
                arcpy.AddField_management(fc,"area","FLOAT")
                arcpy.CalculateField_management(fc, "area", "!SHAPE.area@SQUAREMETERS!", "PYTHON")
                arcpy.MakeFeatureLayer_management(fc, "lyr")
                arcpy.SelectLayerByAttribute_management("lyr", "NEW_SELECTION", ' "area" < 9000 ')  
                #arcpy.SelectLayerByAttribute_management("lyr", "NEW_SELECTION", ' "area" < 250000 ')  #0.25 km2, four 250 m MODIS pixels, use this to select large lakes
                if int(arcpy.GetCount_management("lyr").getOutput(0)) > 0:
                        arcpy.DeleteFeatures_management("lyr")
        if "river" in fc:
                print "process " + fc
                arcpy.AddField_management(fc,"length","FLOAT")
                expression="float(!SHAPE.LENGTH!)"
                arcpy.CalculateField_management(fc, "length", expression,"PYTHON")          
        
        
        


        
        
        



                
            
