# use Miniconda environment
#author = "Kang Yang"
#copyright = "Copyright 2017, Nanjing Greenland Hydrology Group"
#license = "GPL"
#version = "0.1"
#maintainer = "Kang Yang"
#email = "kangyang@nju.edu.cn"
#status = "Production"
#description = "statistics water volumes for different elevation bins"

import arcpy
import os
from arcpy import env
from arcpy.sa import *

arcpy.CheckOutExtension("Spatial")
env.workspace=r'E:\1.GrIS_river_evolution\water_mask\2016\Watson_Isortoq\water_depth'
env.overwriteOutput=True
outputPath=r'E:\1.GrIS_river_evolution\water_mask\2016\Watson_Isortoq\zonalstats'
if os.path.exists(outputPath)==False:
        os.mkdir(outputPath)

eleBin=r'E:\1.GrIS_river_evolution\1_DEM\basin_watson_isortoq_30m_gimp_v2_reclassfication_polygon.shp'
env.extent = "MINOF"


eleBin_pt = outputPath + "\\ele_pt_watervolume.shp"
arcpy.FeatureToPoint_management(eleBin, eleBin_pt, "INSIDE")


tiffs = arcpy.ListRasters("*","tif")
for tiff in tiffs:
    if not 'for_waterMask' in tiff:
        continue
    print "process " + tiff
    zonalRaster = outputPath + "\\" + tiff.split('.')[0] + "_zonalSum.tif"
    outZonalStatistics=ZonalStatistics(eleBin,"ID",tiff,"SUM")
    outZonalStatistics.save(zonalRaster)

env.workspace = outputPath
tiffs = arcpy.ListRasters("*","tif")
for tiff in tiffs:
        if not 'for_waterMask' in tiff:
            continue
        day = (tiff.split("2016")[1])[0:3]
        print day
        ExtractMultiValuesToPoints(eleBin_pt,[[tiff,day]])
        
        


        
        
        



                
            
